/*******************************************************************************
 * 
 * jKiwi -- A virtual makeover and hairstyler application
 * Copyright (c) 2007-2008 Dan Mihai Ile, Maria Joao Roque Barbado Leal
 * 
 * This file is part of jKiwi.
 * 
 * jKiwi is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * jKiwi is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *******************************************************************************/

package utils;

import org.eclipse.swt.SWTException;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.internal.gtk.OS;

/**
 * This class provides easy access to the GNOME GTK system stock icons
 */
public abstract class GtkStockIcon {
		
	/* Stock Icons IDs */
	public static final String GTK_STOCK_DIALOG_AUTHENTICATION			= "gtk-dialog-authentication";
	public static final String GTK_STOCK_DIALOG_INFO					= "gtk-dialog-info";
	public static final String GTK_STOCK_DIALOG_WARNING					= "gtk-dialog-warning";
	public static final String GTK_STOCK_DIALOG_ERROR					= "gtk-dialog-error";
	public static final String GTK_STOCK_DIALOG_QUESTION				= "gtk-dialog-question";

	public static final String GTK_STOCK_DND							= "gtk-dnd";
	public static final String GTK_STOCK_DND_MULTIPLE					= "gtk-dnd-multiple";

	public static final String GTK_STOCK_ABOUT							= "gtk-about";
	public static final String GTK_STOCK_ADD							= "gtk-add";
	public static final String GTK_STOCK_APPLY							= "gtk-apply";
	public static final String GTK_STOCK_BOLD							= "gtk-bold";
	public static final String GTK_STOCK_CANCEL							= "gtk-cancel";
	public static final String GTK_STOCK_CDROM							= "gtk-cdrom";
	public static final String GTK_STOCK_CLEAR							= "gtk-clear";
	public static final String GTK_STOCK_CLOSE							= "gtk-close";
	public static final String GTK_STOCK_COLOR_PICKER					= "gtk-color-picker";
	public static final String GTK_STOCK_CONVERT						= "gtk-convert";
	public static final String GTK_STOCK_CONNECT						= "gtk-connect";
	public static final String GTK_STOCK_COPY							= "gtk-copy";
	public static final String GTK_STOCK_CUT							= "gtk-cut";
	public static final String GTK_STOCK_DELETE							= "gtk-delete";
	public static final String GTK_STOCK_DIRECTORY						= "gtk-directory";
	public static final String GTK_STOCK_DISCONNECT						= "gtk-disconnect";
	public static final String GTK_STOCK_EDIT							= "gtk-edit";
	public static final String GTK_STOCK_EXECUTE						= "gtk-execute";
	public static final String GTK_STOCK_FILE							= "gtk-file";
	public static final String GTK_STOCK_FIND							= "gtk-find";
	public static final String GTK_STOCK_FIND_AND_REPLACE				= "gtk-find-and-replace";
	public static final String GTK_STOCK_FLOPPY							= "gtk-floppy";
	public static final String GTK_STOCK_FULLSCREEN						= "gtk-fullscreen";
	public static final String GTK_STOCK_GOTO_BOTTOM					= "gtk-goto-bottom";
	public static final String GTK_STOCK_GOTO_FIRST						= "gtk-goto-first";
	public static final String GTK_STOCK_GOTO_LAST						= "gtk-goto-last";
	public static final String GTK_STOCK_GOTO_TOP						= "gtk-goto-top";
	public static final String GTK_STOCK_GO_BACK						= "gtk-go-back";
	public static final String GTK_STOCK_GO_DOWN						= "gtk-go-down";
	public static final String GTK_STOCK_GO_FORWARD						= "gtk-go-forward";
	public static final String GTK_STOCK_GO_UP							= "gtk-go-up";
	public static final String GTK_STOCK_HARDDISK						= "gtk-harddisk";
	public static final String GTK_STOCK_HELP							= "gtk-help";
	public static final String GTK_STOCK_HOME							= "gtk-home";
	public static final String GTK_STOCK_INDEX							= "gtk-index";
	public static final String GTK_STOCK_INDENT							= "gtk-indent";
	public static final String GTK_STOCK_INFO							= "gtk-info";
	public static final String GTK_STOCK_UNINDENT						= "gtk-unindent";
	public static final String GTK_STOCK_ITALIC							= "gtk-italic";
	public static final String GTK_STOCK_JUMP_TO						= "gtk-jump-to";
	public static final String GTK_STOCK_JUSTIFY_CENTER					= "gtk-justify-center";
	public static final String GTK_STOCK_JUSTIFY_FILL					= "gtk-justify-fill";
	public static final String GTK_STOCK_JUSTIFY_LEFT					= "gtk-justify-left";
	public static final String GTK_STOCK_JUSTIFY_RIGHT					= "gtk-justify-right";
	public static final String GTK_STOCK_LEAVE_FULLSCREEN				= "gtk-leave-fullscreen";
	public static final String GTK_STOCK_MISSING_IMAGE					= "gtk-missing-image";
	public static final String GTK_STOCK_MEDIA_FORWARD					= "gtk-media-forward";
	public static final String GTK_STOCK_MEDIA_NEXT						= "gtk-media-next";
	public static final String GTK_STOCK_MEDIA_PAUSE					= "gtk-media-pause";
	public static final String GTK_STOCK_MEDIA_PLAY						= "gtk-media-play";
	public static final String GTK_STOCK_MEDIA_PREVIOUS					= "gtk-media-previous";
	public static final String GTK_STOCK_MEDIA_RECORD					= "gtk-media-record";
	public static final String GTK_STOCK_MEDIA_REWIND					= "gtk-media-rewind";
	public static final String GTK_STOCK_MEDIA_STOP						= "gtk-media-stop";
	public static final String GTK_STOCK_NETWORK						= "gtk-network";
	public static final String GTK_STOCK_NEW							= "gtk-new";
	public static final String GTK_STOCK_NO								= "gtk-no";
	public static final String GTK_STOCK_OK								= "gtk-ok";
	public static final String GTK_STOCK_OPEN							= "gtk-open";
	public static final String GTK_STOCK_ORIENTATION_PORTRAIT			= "gtk-orientation-portrait";
	public static final String GTK_STOCK_ORIENTATION_LANDSCAPE			= "gtk-orientation-landscape";
	public static final String GTK_STOCK_ORIENTATION_REVERSE_LANDSCAPE	= "gtk-orientation-reverse-landscape";
	public static final String GTK_STOCK_ORIENTATION_REVERSE_PORTRAIT	= "gtk-orientation-reverse-portrait";
	public static final String GTK_STOCK_PASTE							= "gtk-paste";
	public static final String GTK_STOCK_PREFERENCES					= "gtk-preferences";
	public static final String GTK_STOCK_PRINT							= "gtk-print";
	public static final String GTK_STOCK_PRINT_PREVIEW					= "gtk-print-preview";
	public static final String GTK_STOCK_PROPERTIES						= "gtk-properties";
	public static final String GTK_STOCK_QUIT							= "gtk-quit";
	public static final String GTK_STOCK_REDO							= "gtk-redo";
	public static final String GTK_STOCK_REFRESH						= "gtk-refresh";
	public static final String GTK_STOCK_REMOVE							= "gtk-remove";
	public static final String GTK_STOCK_REVERT_TO_SAVED				= "gtk-revert-to-saved";
	public static final String GTK_STOCK_SAVE							= "gtk-save";
	public static final String GTK_STOCK_SAVE_AS						= "gtk-save-as";
	public static final String GTK_STOCK_SELECT_ALL						= "gtk-select-all";
	public static final String GTK_STOCK_SELECT_COLOR					= "gtk-select-color";
	public static final String GTK_STOCK_SELECT_FONT					= "gtk-select-font";
	public static final String GTK_STOCK_SORT_ASCENDING					= "gtk-sort-ascending";
	public static final String GTK_STOCK_SORT_DESCENDING				= "gtk-sort-descending";
	public static final String GTK_STOCK_SPELL_CHECK					= "gtk-spell-check";
	public static final String GTK_STOCK_STOP							= "gtk-stop";
	public static final String GTK_STOCK_STRIKETHROUGH					= "gtk-strikethrough";
	public static final String GTK_STOCK_UNDELETE						= "gtk-undelete";
	public static final String GTK_STOCK_UNDERLINE						= "gtk-underline";
	public static final String GTK_STOCK_UNDO							= "gtk-undo";
	public static final String GTK_STOCK_YES							= "gtk-yes";
	public static final String GTK_STOCK_ZOOM_100						= "gtk-zoom-100";
	public static final String GTK_STOCK_ZOOM_FIT						= "gtk-zoom-fit";
	public static final String GTK_STOCK_ZOOM_IN						= "gtk-zoom-in";
	public static final String GTK_STOCK_ZOOM_OUT						= "gtk-zoom-out";

	//TODO check if the exceptions occurs as specified in the comment
	// or if there are other exceptions. Missing code for checking:
	//	if (thread == null) error (SWT.ERROR_WIDGET_DISPOSED);
	//  if (thread != Thread.currentThread ()) error (SWT.ERROR_THREAD_INVALID_ACCESS);
	//  if (isDisposed ()) error (SWT.ERROR_DEVICE_DISPOSED);
	//TODO this method should only accept the icon names defined in this class
	/**
	 * Returns the matching standard GTK stock image for the
	 * given constant image name, which should be one of the
	 * icon constants specified in class <code>GtkStockIcon</code>,
	 * the given constant image size, which should be one of
	 * the icon size constants specified in class <code>OS</code>,
	 * and the given constant image orientation, which should
	 * be one of the icon orientation constants specified in
	 * class <code>OS</code>.
	 * This image should not be free'd because it was allocated
	 * by the system, not the application. A value of <code>null</code>
	 * will be returned if error occurred. 
	 *
	 * @param name the GtkStockIcon icon constant
	 * @param size the OS icon size constant
	 * @param orientation the OS icon orientation constant
	 * @return the corresponding image data or <code>null</code>
	 *
	 * @exception SWTException <ul>
	 *    <li>ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver</li>
	 *    <li>ERROR_DEVICE_DISPOSED - if the receiver has been disposed</li>
	 * </ul>
	 * 
	 * @see For icon size constants use:
	 * @see OS#GTK_ICON_SIZE_DIALOG
	 * @see OS#GTK_ICON_SIZE_LARGE_TOOLBAR
	 * @see OS#GTK_ICON_SIZE_MENU
	 * @see OS#GTK_ICON_SIZE_SMALL_TOOLBAR
	 * @see For icon orientation constants use:
	 * @see OS#GTK_TEXT_DIR_LTR
	 * @see OS#GTK_TEXT_DIR_NONE
	 * @see OS#GTK_TEXT_DIR_RTL
	 * 
	 */
	public abstract ImageData createImage (String name, int size, int orientation);
	
}